/*-----------------------------------------------------------------------------
[名称]	shitarabian.cpp
[概要]	アプリケーションオブジェクトクラスの実装
[備考]	なし
[履歴]	2003-02-08	NC		コメント付加(moralog)
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// インクルード
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "shitarabian.h"
#include "MainFrm.h"
#include "shitarabianDoc.h"
#include "shitarabianView.h"
#include "ExeCommon.h"

#include "CustomSettingAsciiArtView.h"
#include "CustomSettingAsciiArtEdit.h"
#include "CustomSettingHTML.h"
#include "CustomSettingCSource.h"
#include "CustomSettingIni.h"
#include "CustomSettingPerl.h"
#include "CustomSettingVisualBasic.h"

#include <locale.h>
#include <malloc.h>
#include <stdio.h>
#include "SettingPath.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//-----------------------------------------------------------------------------
// ファイル内変数
//-----------------------------------------------------------------------------
BOOL			f_bComUse = FALSE;		// COM使用 [-] (TRUE:使用中、FALSE:未使用)
CShitarabianApp	theApp;					// 唯一の CShitarabianApp オブジェクト [-] (-)


///-----------------------------------------------------------------------------
// メッセージマップ
//-----------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CShitarabianApp, CWinApp)
	//{{AFX_MSG_MAP(CShitarabianApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// 標準のファイル基本ドキュメント コマンド
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// 標準の印刷セットアップ コマンド
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()


/*-----------------------------------------------------------------------------
[名称]	コンストラクタ
[機能]	インスタンスの生成。
[戻値]	なし
[備考]	なし
-----------------------------------------------------------------------------*/
CShitarabianApp::CShitarabianApp()
{
}


/*-----------------------------------------------------------------------------
[名称]	初期化
[機能]	アプリケーションの初期化
[戻値]	CWinApp::InitInstance()のヘルプを参照。
[備考]	VBRegularExpressionのためにCOMを使用する。
-----------------------------------------------------------------------------*/
BOOL CShitarabianApp::InitInstance()
{
	AfxEnableControlContainer();

	// 標準的な初期化処理

	//COMを使うときのお約束
	f_bComUse = ( SUCCEEDED(CoInitialize(NULL)) );

	// ロケールの設定（マルチバイト判定のために必要）
	setlocale( LC_ALL, "japanese" );

#ifdef _AFXDLL
	Enable3dControls();		// 共有 DLL の中で MFC を使用する場合にはここを呼び出してください。
#else
	Enable3dControlsStatic();	// MFC と静的にリンクしている場合にはここを呼び出してください。
#endif

	// 設定が保存される下のレジストリ キーを変更します。
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(8);  // 標準の INI ファイルのオプションをローﾄﾞします (MRU を含む)

	// ドキュメント テンプレートを登録します。

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CShitarabianDoc),
		RUNTIME_CLASS(CMainFrame),       // メイン SDI フレーム ウィンドウ
		RUNTIME_CLASS(CShitarabianView));
	AddDocTemplate(pDocTemplate);

	// DDE Execute open を使用可能にします。
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// DDE、file open など標準のシェル コマンドのコマンドラインを解析します。
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		return TRUE;
	}



	// コマンドラインでディスパッチ コマンドを指定します。
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// ドラッグ/ドロップ オープンを許可します
	m_pMainWnd->DragAcceptFiles();

	// 設定が存在しなければデフォルト設定を書き出す
	CString		strGeneralFilename = CSettingPath::GetInstance()->GetFolderPath() + "typegeneral.ini";
	CFileStatus	rStatus;
	if ( !CFile::GetStatus( strGeneralFilename, rStatus ) )
	{
		CCustomSettingAsciiArtView	AsciiArtView;
		CCustomSettingAsciiArtEdit	AsciiArtEdit;
		CCustomSettingHTML			HTML;
		CCustomSettingCSource		CSource;
		CCustomSettingIni			Ini;
		CCustomSettingPerl			Perl;
		CCustomSettingVisualBasic	VisualBasic;

		AsciiArtView.Write();
		AsciiArtEdit.Write();
		HTML.Write();
		CSource.Write();
		Ini.Write();
		Perl.Write();
		VisualBasic.Write();

		((CMainFrame*)m_pMainWnd)->ResetSettingCombo();
	}

	return TRUE;
}


/*-----------------------------------------------------------------------------
[名称]	バージョンダイアログクラス
[用途]	バージョン表示。
[備考]	なし
-----------------------------------------------------------------------------*/
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ダイアログ データ
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_strVersion;
	//}}AFX_DATA

	// ClassWizard 仮想関数のオーバーライドを生成します。
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV のサポート
	//}}AFX_VIRTUAL

// インプリメンテーション
protected:
	//{{AFX_MSG(CAboutDlg)
		// メッセージ ハンドラはありません。
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/*-----------------------------------------------------------------------------
[名称]	コンストラクタ
[機能]	インスタンスの生成。
[戻値]	なし
[備考]	CDialog::CDialogのヘルプを参照。
-----------------------------------------------------------------------------*/
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_strVersion = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_ABOUT_VERSION, m_strVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// メッセージ ハンドラはありません。
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/*-----------------------------------------------------------------------------
[名称]	Aboutハンドラ
[機能]	バージョンダイアログの表示。
[戻値]	なし
[備考]	DEBUG時にはヒープ状態を表示させてみる。（意味あるのか？）
-----------------------------------------------------------------------------*/
void CShitarabianApp::OnAppAbout()
{
	CAboutDlg aboutDlg;

	// アプリ名称
	CString		strTitle;
	strTitle.LoadString( AFX_IDS_APP_TITLE );

	// バージョン情報
	CString		strVersion;
	strVersion.LoadString( IDS_RELEASE_VERSION );

	// 情報表示
	aboutDlg.m_strVersion.Format( "%s ver.%s", strTitle, strVersion );

#ifdef _DEBUG
	{
	   int  heapstatus;
//	   char *buffer;

	   /* ヒープの状態チェック */
	   heapstatus = _heapchk();
	   switch( heapstatus )
	   {
		  case _HEAPOK:
			 AfxMessageBox( "OK - ヒープは正常です。\n" );
			 break;
		  case _HEAPEMPTY:
			 AfxMessageBox( "OK - ヒープは空です。\n" );
			 break;
		  case _HEAPBADBEGIN:
			 AfxMessageBox( "ERROR - ヒープの先頭が異常です。\n" );
			 break;
		  case _HEAPBADNODE:
			 AfxMessageBox( "ERROR - ヒープの中に異常ノードがあります。\n" );
			 break;
	   }
	}
#endif

	aboutDlg.DoModal();
}

/*-----------------------------------------------------------------------------
[名称]	アプリケーション破棄ハンドラ
[機能]	アプリケーションが使用するリソースの解放。
[戻値]	なし
[備考]	COMの解放。
-----------------------------------------------------------------------------*/
void CShitarabianApp::OnFinalRelease() 
{
	// COMの後始末
	if ( f_bComUse )
	{
		//お約束
		CoUninitialize();
	}

	CWinApp::OnFinalRelease();
}
